<?php
/********************************************************************
* mini-pub - Mini PHP Publisher
* -----------------------------
*
* Copyright (C) 2002 Fabio A Mazzarino
* Released under the terms of GNU General Public License version 2
* See COPYING file for more information
*
* File: classRssParser.inc.php
* Descr.: RSS parser class
*
* Authors:
*   Fabio A Mazzarino <mazza at altern.org>
*
* Changes
*   ???/??/2001 - Olivier Dubroca - PHP RSS Class, base code
*   May/28/2002 - mazza - LGPL code reuse
*
* ToDo:
*
* Notes:
*   LGPL code from PHP RSS Class, by Olivier Dubroca
*   Copyright (C) 2001 Olivier Dubroca
*
*******************************************************************/

if(!defined("__CLASS_RSS_PARSER_INC_PHP__")){
define("__CLASS_RSS_PARSER_INC_PHP__", "classRssParser.inc.php");

class rssParser{

function rrssParser(){

}

}



/* Returns the child of a node named by name */ 

function xml_get_child_by_name($xmlNode,$name) {
  $childs_node = $xmlNode->children();
  
    for($i=0;$i<count($childs_node);$i++) { 
      if($childs_node[$i]->name == $name)
	return $childs_node[$i];
    }
    
    return null;
}

/* Additional classes */

class RssItem {
  var $title;
  var $link;
  
  function RssItem ($title,$link) {
    $this->title = $title;
    $this->link = $link;
  }

  function toString() {
    echo "RssItem : \n\t title = $this->title \n\t link = $this->link\n";
  }
}  

class RssChannel {
  var $title;
  var $link;
  var $desc;

  function RssChannel ($title,$link,$desc) {
    $this->title = $title;
    $this->link = $link;
    $this->desc = $desc; 
  }

  function toString() {
    echo "RssChannel : \n\t title = $this->title \n\t link = $this->link\n\t desc = $this->desc\n";
  }
}

class RssImage {
  var $title;
  var $url;
  var $link;

  function RssImage($title,$url,$link) {
    $this->title = $title;
    $this->url = $url;
    $this->link = $link;
  }

  function toString() {
    echo "RssImage : \n\t title = $this->title \n\t link = $this->link\n\t url = $this->url\n";
  }
}

class Rss {
    
  var $rssDoc ;
  var $channel;
  var $image;
  var $items;
  var $count_item;
 
  function extract_rss_channel() {
    $channel_node = xml_get_child_by_name($this->rssDoc->root(),"channel");
    
    if($channel_node) {
      $title_node = xml_get_child_by_name($channel_node,"title") ;
      if($title_node) {
	$title = $title_node->content;
      }

      $link_node = xml_get_child_by_name($channel_node,"link") ;
      if($link_node) {
	$link = $link_node->content;
      }
      
      $desc_node = xml_get_child_by_name($channel_node,"description") ;
      if($desc_node) {
	$desc = $desc_node->content;
      }
    }
    $this->channel = new RssChannel($title,$link,$desc);
  }
  
  function extract_rss_image($nodePtr) {
    $find = false;
    $image_node = xml_get_child_by_name($nodePtr,"image");
    if($image_node) {
      $find = true;
      $title_node = xml_get_child_by_name($image_node,"title") ;
      if($title_node) {
	$title = $title_node->content;
      }
      
      $link_node = xml_get_child_by_name($image_node,"link") ;
      if($link_node) {
	$link = $link_node->content;
      }
      
      $url_node = xml_get_child_by_name($image_node,"url") ;
      if($url_node) {
	$url = $url_node->content;
      }
    }
    $this->image = new RssImage($title,$url,$link);
    return $find;
  }
    
    
    
  function extract_rss_items($nodePtr) {

    $childs = $nodePtr->children();
    $this->items = array();
    
    while(list($key,$node)=each($childs)) {
      if($node->name == "item") {
	$title_node = xml_get_child_by_name($node,"title");
	if($title_node) {
	  if($title_node) { 
	    $title = $title_node->content; 
	  } 
 
	  $link_node = xml_get_child_by_name($node,"link") ; 
	  if($link_node) { 
	    $link = $link_node->content; 
	  }
	  array_push($this->items,new RssItem($title,$link));
	}
      }
    }
    return count($this->items);
  }
  
    
  function Rss($file) {
    $this->rssDoc = xmldocfile($file);
    if($this->rssDoc) {
      $this->extract_rss_channel();
      
      $root_node = $this->rssDoc->root();
      
      if($this->extract_rss_image($root_node) == false) {
	$channel_node = xml_get_child_by_name($root_node,"channel"); 
	$this->extract_rss_image($channel_node);
      }
      
      if(($this->item_count=$this->extract_rss_items($root_node))<1) {
	$channel_node = xml_get_child_by_name($root_node,"channel"); 
	$this->item_count = $this->extract_rss_items($channel_node);
      }
      
    }
    else {
      echo "$file is not a valid xml file\n";
      exit();
    }
  }

  /* Accessors */ 
  function getChannel() {
  	return $this->channel;
  }

  function getImage() {
  	return $this->image;
  }

  function getItems() {
  	return $this->items;
  }

  /* Just for debug */
  function toString() {
    $this->channel->toString();
    $this->image->toString();
    for($i=0;$i<$this->item_count;$i++) {
      $this->items[$i]->toString();
    }
  }
  
  /* Just for fun */
  function toHtml() {
    echo "<br><br>\n";
    echo "<a class=\"image\" href=\"".$this->image->link."\">"; 
    echo "<img align=\"middle\" valign=\"center\" src=\"".$this->image->url."\" border=\"0\"></a>\n";
    echo "<a class=\"title\" href=\"".$this->image->link."\">";
    echo $this->image->title."</a>\n";
    echo "<ul>\n";
    for($i=0;$i<$this->item_count;$i++) {
      echo "<li><a class=\"item\" href=\"".$this->items[$i]->link."\">".$this->items[$i]->title."</a></li>\n";
    }
    echo "</ul>\n";
  }
}

/* Example 
 *
 *
 * $channel = array("file1.rdf","file2.rdf");
 *
 * for($i=0;$i<count($channel);$i++) {
 *  $rss = new Rss($channel[$i]);
 *  $rss->toHtml();
 * }
 *
 */
?>
