<?php 
/********************************************************************
* mini-door - default mini-pub FrontEnd
* ------------------------------
*
* Copyright (C) 2002 Fabio A Mazzarino
* Released under the terms of GNU General Public License version 2
* See COPYING file for more information
*
* File: data.php
* Descr.: a php front-end for .data files editing
*
* Authors:
*   Fabio A Mazzarino <mazza at altern.org>
*
* Changes
*   Jan/25/2002 - mazza - Initial version
*
* ToDo:
*
*******************************************************************/

// include
include("../../mini-pub.php/classDataParser.inc.php");


// ***** G E T / P O S T   R E T R I E V I N G *****
// GET || POST
if(isset($_GET[sFileName]))
  $sFileName = $_GET[sFileName];
else
  $sFileName = $_POST[sFileName];

$sEntryId = $_POST[sEntryId];
$sMarkName = $_POST[sMarkName];

$sNewDataName = $_POST[sNewDataName];
$sNewEntryId = $_POST[sNewEntryId];
$sNewDate = $_POST[sNewDate];

$sNewMarkName = $_POST[sNewMarkName];
$sNewMarkValue = $_POST[sNewMarkValue];

$chkToday = $_POST[chkToday];

$btnUpdateName = $_POST[btnUpdateName];

$btnUpEntry = $_POST[btnUpEntry];
$btnDownEntry = $_POST[btnDownEntry];
$btnInsertEntry = $_POST[btnInsertEntry];
$btnCloneEntry = $_POST[btnCloneEntry];
$btnEditEntry = $_POST[btnEditEntry];
$btnDelEntry = $_POST[btnDelEntry];
$btnRemoveEntry = $_POST[btnRemoveEntry];
$btnCancelEntry = $_POST[btnCancelEntry];

$btnInsertMark = $_POST[btnInsertMark];
$btnEditMark = $_POST[btnEditMark];
$btnUpdateMark = $_POST[btnUpdateMark];
$btnDelMark = $_POST[btnDelMark];
$btnRemoveMark = $_POST[btnRemoveMark];
$btnCancelMark = $_POST[btnCancelMark];

// object creation
$oData = new dataParser();

// http adjustments
if($sEntryId == "null")
  unset($sEntryId);
if($sMarkName == "null")
  unset($sMarkName);
if(get_magic_quotes_gpc()) {
  $sMarkName = stripslashes($sMarkName);
  $sNewDataName = stripslashes($sNewDataName);
  $sNewMarkName = stripslashes($sNewMarkName);
  $sNewMarkValue = stripslashes($sNewMarkValue);
}


// ***** F I L E   L O A D I N G *****
$oData->read($sFileName);

// ***** V A R I A B L E   I N I T I A L I Z A T I O N *****
$sDataName = $oData->sDataName;

$sEntryAction = "<input type=\"submit\" name=\"btnInsertEntry\" value=\"Insert Entry\">";
$sEntryAction .= "\n<input type=\"submit\" name=\"btnCloneEntry\" value=\"Clone Current\">";

$sMarkAction = "<input type=\"submit\" name=\"btnInsertMark\" value=\"Insert Mark\">";

$sEntryIdEnable = "";
$sMarkNameEnable ="";

// ***** E V E N T   H A N D L I N G *****
if(isset($btnUpdateName)){		// update name
  $oData->sDataName = $sNewDataName;
  $oData->write($sFileName);
  $sDataName = $oData->sDataName;
  unset($sEntryId);
}

if(isset($btnUpEntry)){
  $aOriginal = $oData->aEntries;
  reset($aOriginal);
  $bFirst = true;
  while(list($sThisEntryId, $aThisEntry) = each($aOriginal)){
    // if first there's no where up
    if($sThisEntryId === $sEntryId && $bFirst) 
      break;

    if($bFirst){
      // nothing to do with first
      $bFirst = false;
      // $aNew[$sThisEntryId] = $aOriginal[$sThisEntryId];
      $sOldEntryId = $sThisEntryId;
      continue;
    }

    if($sThisEntryId === $sEntryId) {
      $aNew[$sEntryId] = $aOriginal[$sEntryId];
    }
    else {
      $aNew[$sOldEntryId] = $aOriginal[$sOldEntryId];
      $sOldEntryId = $sThisEntryId;
    }
  }

  if($sThisEntryId === $sEntryId && $bFirst) 
    $aNew = $aOriginal;
  else
    $aNew[$sOldEntryId] = $aOriginal[$sOldEntryId];

  $oData->aEntries = $aNew;
  $oData->write($sFileName);
}
if(isset($btnDownEntry)){
  $aOriginal = $oData->aEntries;
  reset($aOriginal);

  while(list($sThisEntryId, $aThisEntry) = each($aOriginal)){
    if($sThisEntryId === $sEntryId) {
      $bFound = true;
      continue;
    }

    if($bFound) {
      $aNew[$sThisEntryId] = $aOriginal[$sThisEntryId];
      $aNew[$sEntryId] = $aOriginal[$sEntryId];
      $bFound = false;
      continue;
    }
    $aNew[$sThisEntryId] = $aOriginal[$sThisEntryId];
  }
  if($bFound)
    $aNew[$sEntryId] = $aOriginal[$sEntryId];

  $oData->aEntries = $aNew;
  $oData->write($sFileName);
}


if(isset($btnInsertEntry)){		// insert entry
  if(isset($sNewEntryId)) {
    // filling today or date typed
    if(!isset($chkToday))
      $oData->aEntries[$sNewEntryId][DATE] = $sNewDate;
    else 
      $oData->aEntries[$sNewEntryId][DATE] = date("Ymd");
    $sEntryId = $sNewEntryId;

    // save now!
    $oData->write($sFileName);
  }

}
if(isset($btnCloneEntry)){		// clone entry
  if(isset($sNewEntryId) && isset($sEntryId)){
    // original sample
    $aOriginal = $oData->aEntries[$sEntryId];
  
    // clone
    while(list($sThisMark, $sValue) = each($aOriginal))
      $aClone[$sThisMark] = "";
    // check date or today
    if(!isset($chkToday))
      $aClone[DATE] = $sNewDate;
    else 
      $aClone[DATE] = date("Ymd");

   // he's alive!
   $oData->aEntries[$sNewEntryId] = $aClone;
   $sEntryId = $sNewEntryId;

   // don't forget to save
   $oData->write($sFileName);
  }
}
if(isset($btnEditEntry)){		// edit entry
  $sEntryAction = "<input type=\"submit\" name=\"btnUpdateEntry\" value=\"Update Entry\">";
  $sEntryIdEnable = "disabled";
}
if(isset($btnUpdateEntry)){		// update entry
  if(!isset($chkToday)) 
    $oData->aEntries[$sEntryId][DATE] = $sNewDate;
  else
    $oData->aEntries[$sEntryId][DATE] = date("Ymd");

  $oData->write($sFileName);
}
if(isset($btnDelEntry)){		// delete entry
  $sEntryAction = "<input type=\"submit\" name=\"btnRemoveEntry\" value=\"Remove Entry\">";
  $sMessage = "CAUTION! Current Entry will be removed!";
}
if(isset($btnRemoveEntry)){		// delete entry confirmation
  if(isset($sEntryId)) {
    unset($oData->aEntries[$sEntryId]);
    $oData->write($sFileName);
    unset($sEntryId);
  }
}
if(isset($btnCancelEntry)){
  unset($sEntryId);
}

if(isset($btnInsertMark)){
  if(isset($sEntryId) && isset($sNewMarkName)) {
    $oData->aEntries[$sEntryId][$sNewMarkName] = $sNewMarkValue;
    $oData->write($sFileName);
  }
}
if(isset($btnEditMark)){
  $sMarkAction = "<input type=\"submit\" name=\"btnUpdateMark\" value=\"Update Mark\">";
    $sMarkNameEnable = "disabled";
}
if(isset($btnUpdateMark)){
  $oData->aEntries[$sEntryId][$sMarkName] = $sNewMarkValue;
  $oData->write($sFileName);
}
if(isset($btnDelMark)){
  $sMarkAction = "<input type=\"submit\" name=\"btnRemoveMark\" name=\"Remove Mark\">";
}
if(isset($btnRemoveMark)){
  unset($oData->aEntries[$sEntryId][$sMarkName]);
  $oData->write($sFileName);
  unset($sMarkName);
}
if(isset($btnCancelMark)){
  unset($sMarkName);
}


// ***** L I S T   B U I L D I N G *****
// entries
$sEntriesList = "";
if(is_array($oData->aEntries)) reset($oData->aEntries);
while(list($sThisId, $aEntry) = each($oData->aEntries)) {
  $sEntriesList .= "\t<option value=\"$sThisId\"";
  if($sThisId === $sEntryId)
    $sEntriesList .= " selected";
  $sEntriesList .= ">$sThisId</option>\n";
}

// marks
if(isset($sEntryId)){
  $sMarksList = "";
  if(is_array($oData->aEntries[$sEntryId])) reset($oData->aEntries[$sEntryId]);
  while(isset($oData->aEntries[$sEntryId]) &&
    list($sThisName, $sThisValue) = each($oData->aEntries[$sEntryId])){
    if($sThisName == "DATE")
      continue;
    $sMarksList .= "\t<option value=\"$sThisName\"";
    if($sMarkName == $sThisName)
      $sMarksList .= " selected";
    $sMarksList .= ">$sThisName</option>\n";
  }

  // form filling
  $sDate = $oData->aEntries[$sEntryId][DATE];
}


if(isset($sEntryId) && isset($sMarkName)){
  // fill form
  $sMarkValue = $oData->aEntries[$sEntryId][$sMarkName];
}


?>



<html>
<head>
<link rel="stylesheet" type="text/css" href="minipub.css">
<title>Edit mini-pub .data file</title>
</head>

<body>


<form action="data.php" method="post">

<center>
<table cellspacing="4" cellpadding="4" border="0">
<tr><td class="innercells" colspan="2">
	<img src="mini-pub.png">
</td></tr>
<tr><td class="title" colspan="2">
	Edit .data File<br>
	<font class="msg"><?php echo $sMessage; ?></font>
</td></tr>
<tr><td class="name" valign="top"><b>.data File Name:</b></td>
<td class="innercells" valign="top">
	<input type="hidden" name="sFileName" value="<?php echo $sFileName; ?>">
	<i><?php echo $sFileName; ?></i>
</td></tr>
<tr><td class="name" valign="top"><b>.data Name:</b></td>
<td class="innercells" valign="top">
	<input type="text" name="sNewDataName" value="<?php echo $sDataName; ?>">
</td></tr>
<tr><td class="name" valign="top">&nbsp;</td>
<td class="innercells" valign="top">
	<input type="submit" name="btnUpdateName" value="Update">
</td></tr>

<tr><td class="name" valign="top"><b>Entries:</b></td>
<td class="innercells" valign="top">
	<select name="sEntryId">
	<option value="null">-- Select --</option>
	<?php echo $sEntriesList; ?>
	</select>
	<input type="submit" name="btnUpEntry" value="Up">
	<input type="submit" name="btnDownEntry" value="Down">
</td></tr>
<tr><td class="name">&nbsp;</td>
<td class="innercells" valign="top">
	<input type="submit" name="btnEditEntry" value="Edit Entry">
	<input type="submit" name="btnDelEntry" value="Delete Entry">
</td></tr>

<tr><td class="name" colspan="2"> </td></tr>

<tr><td class="name" valign="top"><b>ID:</b></td>
<td class="innercells" valign="top">
	<input type="text" name="sNewEntryId" value="<?php echo $sEntryId; ?>" <?php echo $sEntryIdEnable; ?>>
</td></tr>
<tr><td class="name" valign="top"><b>Date:</b></td>
<td class="innercells" valign="top">
	<input type="text" name="sNewDate" value="<?php echo $sDate; ?>"><br>
	<input type="checkbox" name="chkToday" value=\"Today\"> Today
</td></tr>
<tr><td class="name">&nbsp;</td>
<td class="innercells">
	<?php echo $sEntryAction; ?>
	<input type="submit" name="btnCancelEntry" value="Cancel">
</td></tr>

<tr><td class="name" valign="top"><b>Marks:</b></td>
<td class="innercells" valign="top">
	<select name="sMarkName">
	<option value="null">-- Select --</option>
	<?php echo $sMarksList; ?>
	</select>
</td></tr>
<tr><td class="name">&nbsp;</td>
<td class="innercells" valign="top">
	<input type="submit" name="btnEditMark" value="Edit Mark">
	<input type="submit" name="btnDelMark" value="Delete Mark">
</td></tr>

<tr><td class="name" colspan="2">
	<input type="hidden" name="sSelMarkName" value="<?php echo $sSelMarkName; ?>">
</td></tr>

<tr><td class="name" valign="top"><b>Mark Name:</b></td>
<td class="innercells" valign="top">
	<input type="text" name="sNewMarkName" value="<?php echo $sMarkName; ?>" <?php echo $sMarkNameEnable; ?>>
</td></tr>
<tr><td class="name" valign="top"><b>Mark Value:</b></td>
<td class="innercells" valign="top">
	<textarea name="sNewMarkValue" cols="40" rows="10"><?php echo $sMarkValue; ?></textarea>
</td></tr>
<tr><td class="name">&nbsp;</td>
<td class="innercells">
	<?php echo $sMarkAction; ?>
	<input type="submit" name="btnCancelMark" value="Cancel">
</td></tr>

<tr><td colspan="2">&nbsp;</td></tr>

</table>
</center>
</form>
</body>
</html>
