<?php 
/********************************************************************
* mini-door - mini-pub FrontEnd
* ------------------------------
*
* Copyright (C) 2002, 2003 Fabio A Mazzarino
* Released under the terms of GNU General Public License version 2
* See COPYING file for more information
*
* File: dir.php
* Descr.: a php front-end for selecting edit .pub, .data and other 
*         files
*
* Authors:
*   Fabio A Mazzarino <mazza at altern.org>
*
* ToDo:
*
*******************************************************************/

// includes
include("../../mini-pub.php/classPubParser.inc.php");
include("../../mini-pub.php/classDataParser.inc.php");

// ***** P O S T / G E T   M A N A G E M E N T *****
// GET or POST variables
if(isset($_GET[sDir]))
  $sDir = $_GET[sDir];
if(isset($_POST[sDir]))
  $sDir = $_POST[sDir];
if(isset($_GET[sChgDir]))
  $sChgDir = $_GET[sChgDir];
if(isset($_POST[sChgDir]))
  $sChgDir = $_POST[sChgDir];

$sNewPubFileName = $_POST[sNewPubFileName];
$sNewDataFileName = $_POST[sNewDataFileName];
$sNewLayoutFileName = $_POST[sNewLayoutFileName];

$btnNewPub = $_POST[btnNewPub];
$btnNewData = $_POST[btnNewData];
$btnNewLayout = $_POST[btnNewLayout];

if(!isset($sDir))
  $sDir = getcwd();

// ***** I N I T I A L I Z A T I O N *****

// ***** V A R I A B L E   I N I T I A L I Z A T I O N *****

// ***** E V E N T   H A N D L I N G *****
if(isset($sDir)) {
  chdir($sDir);
}
if(isset($sChgDir)) {
  chdir($sChgDir);
  $sDir = getcwd();
}
if(isset($btnNewPub)) {
  $oPub = new pubParser();
  $oPub->write("$sDir/$sNewPubFileName");
  header("Location: pub.php?sFileName=$sDir/$sNewPubFileName");
  exit;
}
if(isset($btnNewData)) {
  $oData = new dataParser();
  $oData->write("$sDir/$sNewDataFileName");
  header("Location: data.php?sFileName=$sDir/$sNewDataFileName");
  exit;
}
if(isset($btnNewLayout)) {
  $sMute = `touch $sDir/$sNewLayoutFileName`;
  header("Location: edit.php?sFileName=$sDir/$sNewLayoutFileName");
  exit;
}

// ***** L I S T   B U I L D I N G *****
$ctDir = 0;
$ctPub = 0;
$ctData = 0;
$ctLayout = 0;
$ctOther = 0;
$hDir = @opendir($sDir);
while(false !== ($sFileName = readdir($hDir))) {
  // directories
  if(is_dir("$sDir/$sFileName")) {
    if($sFileName == ".") 
      continue;
    if($ctDir % 2 == 0)
      $sDirList .= "<tr>";
    $sDirList .= "<td width=\"300\">";
    $sDirList .= "<a href=\"dir.php?sDir=$sDir&sChgDir=$sFileName\">";
    $sDirList .= "$sFileName</a></td>";
    if($ctDir % 2 == 1)
      $sDirList .= "</tr>";
    $ctDir++;
  }
  // .pub files
  elseif(ereg("\.pub", $sFileName)) {
    // ereg used to avoid selecting sample.pub.data
    if($ctPub % 2 == 0)
      $sPubList .= "<tr>";
    $sPubList .= "<td width=\"300\" align=\"left\">";
    $sPubList .= "<a href=\"pub.php?sFileName=$sDir/$sFileName\">";
    $sPubList .= "$sFileName</a></td>";
    if($ctPub % 2 == 1)
      $sPubList .= "</tr>";
    $ctPub++;
  }
  // .data files
  elseif(ereg("\.data", $sFileName)) {
    // ereg used to avoid selecting sample.data.pub
    if($ctData % 2 == 0)
      $sDataList .= "<tr>";
    $sDataList .= "<td width=\"300\" align=\"left\">";
    $sDataList .= "<a href=\"data.php?sFileName=$sDir/$sFileName\">";
    $sDataList .= "$sFileName</a></td>";
    if($ctData % 2 == 1)
      $sDataList .= "</tr>";
    $ctData++;
  }
  // .layout files
  elseif(ereg("\.layout", $sFileName)) {
    // ereg used to avoid selecting sample.data.layout.pub
    if($ctLayout % 2 == 0)
      $sLayoutList .= "<tr>";
    $sLayoutList .= "<td width=\"300\" align=\"left\">";
    $sLayoutList .= "<a href=\"edit.php?sFileName=$sDir/$sFileName\">";
    $sLayoutList .= "$sFileName</a></td>";
    if($ctLayout % 2 == 1)
      $sLayoutList .= "</tr>";
    $ctLayout++;
  }
  // images files (.png, .gif, .jpg/.jpeg)
  elseif(ereg("\.gif", $sFileName) || ereg("\.png", $sFileName) ||
         ereg("\.jpg", $sFileName) || ereg("\.jpeg", $sFileName)) {
    if($ctOther % 2 == 0)
      $sOtherList .= "<tr>";
    $sOtherList .= "<td width=\"300\" align=\"left\">";
    $sOtherList .= "<a href=\"img.php?sFileName=$sDir/$sFileName\">";
    $sOtherList .= "$sFileName</a></td>";
    if($ctOther % 2 == 1)
      $sOtherList .= "</tr>";
    $ctOther++;
  }
  else {
    if($ctOther % 2 == 0)
      $sOtherList .= "<tr>";
    $sOtherList .= "<td width=\"300\" align=\"left\">";
    $sOtherList .= "<a href=\"cat.php?sFileName=$sDir/$sFileName\">";
    $sOtherList .= "$sFileName</a></td>";
    if($ctOther % 2 == 1)
      $sOtherList .= "</tr>";
    $ctOther++;
  }
}


?>

<html>
<head>
<link rel="stylesheet" type="text/css" href="minipub.css">
<title>mini-pub Directory Content</title>
</head>

<body>
<form method="post" action="dir.php">

<input type="hidden" name="sDir" value="<?php echo $sDir; ?>">

<center>
<table cellspacing="4" cellpadding="4" border="0">
<tr><td class="innercells" colspan="2">
	<img src="mini-pub.png">
</td></tr>
<tr><td class="title" colspan="2">
	Directory Content<br>
	<font class="msg"><?php echo $sMessage; ?></font>
</td></tr>

<tr><td class="name" valign="top"><b>Current Path:</b></td>
<td class="innercells" valign="top">
	<?php echo $sDir; ?>
</td></tr>
<tr><td class="name" valign="top"><b>Directories:</b></td>
<td class="innercells" valign="top">
	<table border="0">
	<?php echo $sDirList; ?>
	</table>
</td></tr>
<tr><td class="name" valign="top"><b>.pub Files:</b></td>
<td class="innercells" valign="top">
	<table border="0">
	<?php echo $sPubList; ?>
	</table>
	<p>
	<input type="text" name="sNewPubFileName" size="40">
	&nbsp;&nbsp;&nbsp;
	<input type="submit" name="btnNewPub" value="New Pub File">
</td></tr>

<tr><td class="name" valign="top"><b>.data Files:</b></td>
<td class="innercells" valign="top">
	<table border="0">
	<?php echo $sDataList; ?>
	</table>
	<p>
	<input type="text" name="sNewDataFileName" size="40">
	&nbsp;&nbsp;&nbsp;
	<input type="submit" name="btnNewData" value="New Data File">
</td></tr>

<tr><td class="name" valign="top"><b>.layout Files:</b></td>
<td class="innercells" valign="top">
	<table border="0">
	<?php echo $sLayoutList; ?>
	</table>
	<p>
	<input type="text" name="sNewLayoutFileName" size="40">
	&nbsp;&nbsp;&nbsp;
	<input type="submit" name="btnNewLayout" value="New Layout File">
</td></tr>
<tr><td class="name" valign="top"><b>Other Files:</b></td>
<td class="innercells" valign="top">
	<table border="0">
	<?php echo $sOtherList; ?>
	</table>
</td></tr>


</table>
</center>

</form>
</body>
</html>
