<?php 
/********************************************************************
* mini-door - mini-pub FrontEnd
* ------------------------------
*
* Copyright (C) 2002 Fabio A Mazzarino
* Released under the terms of GNU General Public License version 2
* See COPYING file for more information
*
* File: pub.php
* Descr.: a php front-end for pub files editing
*
* Authors:
*   Fabio A Mazzarino <mazza at altern.org>
*
* ToDo:
*
*******************************************************************/

// includes
include("../../mini-pub.php/classPubParser.inc.php");

// ***** P O S T / G E T   M A N A G E M E N T *****

// GET or POST variables
if(isset($_GET[sFileName]))
  $sFileName = $_GET[sFileName];
if(isset($_POST[sFileName]))
  $sFileName = $_POST[sFileName];

$btnUpdatePub = $_POST[btnUpdatePub];
$btnPreviewPub = $_POST[btnPreviewPub];
$btnInsertTempl = $_POST[btnInsertTempl];
$btnEditTempl = $_POST[btnEditTempl];
$btnUpdateTempl = $_POST[btnUpdateTempl];
$btnDelTempl = $_POST[btnDelTempl];
$btnRemoveTempl = $_POST[btnRemoveTempl];
$btnCancelTempl = $_POST[btnCancelTempl];
$btnUpTempl = $_POST[btnUpTempl];
$btnDownTempl = $_POST[btnDownTempl];

$sNewPubName = $_POST[sNewPubName];
$sNewHeader = $_POST[sNewHeader];
$sNewFooter = $_POST[sNewFooter];

$iTemplId = $_POST[iTemplId];
$sNewTempl = $_POST[sNewTempl];

// get/post treatment
// need strpslashes?
if(get_magic_quotes_gpc()) {
  $sNewPubName = stripslashes($sNewPubName);
  $sNewHeader = stripslashes($sNewHeader);
  $sNewFooter = stripslashes($sNewFooter);
  $sNewTempl = stripslashes($sNewTempl);
}


// ***** I N I T I A L I Z A T I O N *****
// object creation
$oPub = new pubParser();


// ***** F I L E   L O A D I N G *****
$oPub->read($sFileName);

// ***** V A R I A B L E   I N I T I A L I Z A T I O N *****
$sPubName = $oPub->sPubName;
$sHeader = $oPub->sHeader;
$sFooter = $oPub->sFooter;

$sTemplAction = "<input type=\"submit\" name=\"btnInsertTempl\" value=\"Insert Template\">";

// ***** E V E N T   H A N D L I N G *****
if(isset($btnUpdatePub)) {
  $oPub->sPubName = $sPubName = $sNewPubName;
  $oPub->sHeader = $sHeader = $sNewHeader;
  $oPub->sFooter = $sFooter = $sNewFooter;

  $oPub->write($sFileName);
}
if(isset($btnPreviewPub)){
  header("Location: previewpub.php?sFileName=$sFileName");
  return;
}
if(isset($btnInsertTempl)){
  $oPub->aTempls[] = $sNewTempl;
  $oPub->write($sFileName);
}
if(isset($btnEditTempl)){
  if(isset($iTemplId)) {
    $sTempl = $oPub->aTempls[$iTemplId];

    $sTemplAction = "<input type=\"submit\" name=\"btnUpdateTempl\" value=\"Update Template\">";
  }
}
if(isset($btnUpdateTempl)){
  $oPub->aTempls[$iTemplId] = $sNewTempl;

  $oPub->write($sFileName);
  unset($iTemplId);
}
if(isset($btnDelTempl)){
  if(isset($iTemplId)){
    $sTempl = $oPub->aTempls[$iTemplId];

    $sTemplAction = "<input type=\"submit\" name=\"btnRemoveTempl\" value=\"Remove Template\">";
  }
}
if(isset($btnRemoveTempl)) {
  $aOriginal = $oPub->aTempls;
  while(list($iThisTemplId, $sThisTempl) = each($aOriginal)) {
    if($iThisTemplId != $iTemplId)
      $aNew[$iThisTemplId] = $aOriginal[$iThisTemplId];
  }
  $oPub->aTempls = $aNew;
  $oPub->write($sFileName);

  $oPub->read($sFileName);
  unset($iTemplId);
}
if(isset($btnUpTempl)){
  $nTempls = count($oPub->aTempls);
  // not empty and not first
  if($nTempls != 0 && $iTemplId != 0) {
    $aOriginal = $oPub->aTempls;

    $iOldTemplId = 0;
    for($ctTempl=1; $ctTempl<$nTempls; $ctTempl++) {
      if($ctTempl == $iTemplId) {
        $aNew[] = $aOriginal[$iTemplId];
      }
      else {
        $aNew[] = $aOriginal[$iOldTemplId];
	$iOldTemplId = $ctTempl;
      }
    }
    $aNew[] = $aOriginal[$iOldTemplId];

    $oPub->aTempls = $aNew;
    $oPub->write($sFileName);
  }
}
if(isset($btnDownTempl)) {
  $nTempls = count($oPub->aTempls);
  // not empty and not last
  if($nTempls != 0 && ($iTemplId + 1) != $nTempls) {
    $aOriginal = $oPub->aTempls;

    $iOldTemplId = 0;
    $bFound = false;
    for($ctTempl=1; $ctTempl<$nTempls; $ctTempl++){

      if(!$bFound && $iOldTemplId == $iTemplId) {
        $aNew[] = $aOriginal[$ctTempl];
	$bFound = true;
      }
      else {
        $aNew[] = $aOriginal[$iOldTemplId];
	$iOldTemplId = $ctTempl;
      }
    }
    $aNew[] = $aOriginal[$iOldTemplId];

    $oPub->aTempls = $aNew;
    $oPub->write($sFileName);
  }
}
if(isset($btnCancelTempl)){
  unset($iTemplId);
}

// ***** L I S T   B U I L D I N G *****
// templates
$sTemplsList = "";
if(is_array($oPub->aTempls)) reset($oPub->aTempls);
while(list($iThisTemplId, $sThisTempl) = each($oPub->aTempls)) {
  $sTemplsList .= "\t<option value=\"$iThisTemplId\"";
  if($iThisTemplId == $iTemplId && isset($iTemplId))
    $sTemplsList .= " selected";
  $sTemplsList .= ">$iThisTemplId</option>\n";
}

?>



<html>
<head>
<link rel="stylesheet" type="text/css" href="minipub.css">
<title>Edit mini-pub .pub file</title>
</head>

<body>

<form action="pub.php" method="post">

<center>
<table cellspacing="4" cellpadding="4" border="0">
<tr><td class="innercells" colspan="2">
	<img src="mini-pub.png">
</td></tr>
<tr><td class="title" colspan="2">
	Edit .pub File<br>
	<font class="msg"><?php echo $sMessage; ?></font>
</td></tr>

<tr><td class="name" valign="top"><b>File Name:</b></td>
<td class="innercells" valign="top">
	<i><?php echo $sFileName; ?></i>
	<input type="hidden" name="sFileName" value="<?php echo $sFileName; ?>">
</td></tr>
<tr><td class="name" valign="top"><b>Pub Name:</b></td>
<td class="innercells" valign="top">
	<input type="text" name="sNewPubName" value="<?php echo $sPubName; ?>">
</td></tr>

<tr><td class="name" valign="top"><b>Header:</b></td>
<td class="innercells" valign="top">
	<textarea name="sNewHeader" rows="3" cols="50"><?php echo $sHeader; ?></textarea>
</td></tr>
<tr><td class="name" valign="top"><b>Footer:</b></td>
<td class="innercells" valign="top">
	<textarea name="sNewFooter" rows="3" cols="50"><?php echo $sFooter; ?></textarea>
</td></tr>
<tr><td class="name" valign="top">&nbsp;</td>
<td class="innercells" valign="top">
	<input type="submit" name="btnUpdatePub" value="Update Pub">
	<input type="submit" name="btnPreviewPub" value="Preview Pub">
</td></tr>

<tr><td class="name" colspan="2"> </td></tr>

<tr><td class="name" valign="top"><b>Templates:</b></td>
<td class="innercells" valign="top">
	<select name="iTemplId">
	<option value="null">-- Select --</option>
	<?php echo $sTemplsList; ?>
	</select>
	<input type="submit" name="btnUpTempl" value="Up">
	<input type="submit" name="btnDownTempl" value="Down">
</td></tr>
<tr><td class="name" valign="top">&nbsp;</td>
<td class="innercells" valign="top">
	<input type="submit" name="btnEditTempl" value="Edit Template">
	<input type="submit" name="btnDelTempl" value="Delete Template">
</td></tr>

<tr><td class="name" colspan="2"> </td></tr>

<tr><td class="name" valign="top"><b>Template:</b></td>
<td class="innercells" valign="top">
	<textarea name="sNewTempl" rows="5" cols="50"><?php echo $sTempl; ?></textarea>
</td></tr>
<tr><td class="name" valign="top">&nbsp;</td>
<td class="innercells" valign="top">
	<?php echo $sTemplAction; ?>
	<input type="submit" name="btnCancelTempl" value="Cancel">
</td></tr>

</table>
</center>
</form>
</body>
</html>
